#pragma once

class LiveTicksUpdater;
class FXConnectHost :
    public BaseHostImpl
{
public:
    FXConnectHost(IO2GSession *session, const std::string &csvSource);
    ~FXConnectHost();

    HANDLE getLoaderFinishedEvent();

    virtual IIndicatorSource *getHistory(IInstance *instance, int cookie, const char *instrument, const char *period, DATE from, DATE to, bool bid, const char **error);
    int getTradingDayOffset();
    int getTradingWeekOffset();

    /** Stubs. */
    const char *getVersion(void) { std::cout << "Called FXConnectHost::getVersion() stub" << std::endl; return ""; }
    void trace(IInstance *,const char *) { std::cout << "Called FXConnectHost::trace() stub" << std::endl; }
    ITradingDataTable *findTable(const char *) { std::cout << "Called FXConnectHost::findTable() stub" << std::endl; return NULL; }
    bool extendHistory(IInstance *,int,IIndicatorSource *,DATE,DATE,const char **) { std::cout << "Called FXConnectHost::extendHistory() stub" << std::endl; return false; }
    IIndicatorSource *getAskPrice(IInstance *,const char **) { std::cout << "Called FXConnectHost::getAskPrice() stub" << std::endl; return NULL; }
    IIndicatorSource *getBidPrice(IInstance *,const char **) { std::cout << "Called FXConnectHost::getBidPrice() stub" << std::endl; return NULL; }
    DATE convertTime(int,int,DATE) { std::cout << "Called FXConnectHost::convertTime() stub" << std::endl; return 0.; }

private:
    IO2GSession *mSession;
    std::string mCSVSource;
    LiveTicksUpdater *mLiveTicksUpdater;
    int mTradingDayOffset;
    int mTradingWeekOffset;

    HistoryLoader *mLoader;
    HANDLE mLoaderFinishedEvent;

    IO2GOfferRow *getOffer(const char *instrument);
};
