#pragma once

class Bar;
class CIndicatorBarSource :
    public IIndicatorBarSource
{
private:
    class IndicatorBar
    {
    public:
        Bar *bar;
        int serial;

        IndicatorBar(Bar *_bar, int _serial) : bar(_bar), serial(_serial) {}
        bool operator <(const IndicatorBar &comparend) const { return bar->date < comparend.bar->date; }
        bool operator >(const IndicatorBar &comparend) const { return bar->date > comparend.bar->date; }
    };
public:
    CIndicatorBarSource(const char *timeframe, const char *instrument, double pipSize, int precision, bool isBid);

    const char *getName();

    int size();

    bool isBar();

    bool hasData(int index) ;

    bool supportsVolume();
    int  getFirstPeriod();

    double date(int index);
    double getDate(int index);

    int getSerial(int index);

    const char *getInstrument();
    void setInstrument(const char *instrument);
    const char *getTimeframe();

    double getPipSize();
    void setPipSize(double pipSize);

    bool isBid();
    bool isAlive();

    int getPrecision();
    void setPrecision(int precision);

    int getDisplayPrecision();
    double getOpen(int index);
    double getHigh(int index);
    double getLow(int index);
    double getClose(int index);
    double getVolume(int index);
    bool getOHLC(int index, double &open, double &high, double &low, double &close);

    const char *getBarSize(void);

    void updateBar(int index, double open, double high, double low, double close, int volumeDiff);
    void addBar(Bar* bar);

    CIndicatorBarSource *getSlice(DATE from, DATE to);

    void release();

private:
    std::vector<IndicatorBar> mBars;
    std::string mInstrument;
    std::string mTimeframe;
    double mPipSize;
    int mPrecision;
    int mSerial;
    bool mIsBid;

    sample_tools::Mutex mMutex;
};
