#pragma once

class ResponseListener;
class LiveTicksUpdater
{
public:
    LiveTicksUpdater(IO2GSession *session,
                     int tradingDayOffset,
                     int tradingWeekOffset);
    ~LiveTicksUpdater(void);

    void subscribeOfferUpdates(IIndicatorInstance *indicatorInst,
                               CIndicatorBarSource *source);

    void unsubscribeUpdates();
    void onNewTick(IO2GOfferRow *offer);
private:
    IO2GSession *mSession;
    IIndicatorInstance *mIndicatorInstance;
    CIndicatorBarSource *mSource;
    ResponseListener *mResponseListener;
    sample_tools::Mutex mMutex;

    Bar *mBarConstructed;
    CandlePeriod::Unit mBarUnit;
    int mBarUnitLength;
    int mTradingDayOffset;
    int mTradingWeekOffset;
    DATE mLastBarUpdateMinute;
    int mLastBarMinuteVolume;
};
