#pragma once

class LiveTicksUpdater;
class ResponseListener :
    public IO2GResponseListener
{
private:
    /** Reference counter. */
    long mRefCount;

    /** Session object. */
    IO2GSession *mSession;

    /** Request ID we are waiting for. */
    std::string mRequestID;

    /** Event handles. */
    HANDLE mRequestEvent;

    IO2GResponse *mLastResponse;
    std::string mError;
    bool mHasError;

    LiveTicksUpdater *mLiveTicksUpdater;

protected:
    /** Destructor. */
    virtual ~ResponseListener();

public:
    ResponseListener(IO2GSession *session);

    /** Increase reference counter. */
    virtual long addRef();

    /** Decrease reference counter. */
    virtual long release();

    /** Set request. */
    void setRequest(const char *requestID);

    /** Request execution completed data handler. */
    virtual void onRequestCompleted(const char * requestId, IO2GResponse  *response = 0);

    /** Request execution failed data handler. */
    virtual void onRequestFailed(const char *requestId , const char *error);

    /** Request update data received data handler. */
    virtual void onTablesUpdates(IO2GResponse *data);

    HANDLE getRequestEvent();

    IO2GResponse *getLastResponse();
    bool hasError();
    const char *getError();

    void setTicksUpdater(LiveTicksUpdater *updater);
};

