#pragma once

class SampleParams
{
public:
    class Strings
    {
    public:
        static const char *instrumentNotSpecified;
        static const char *timeframeNotSpecified;
        static const char *dateFromNotSpecified;
        static const char *dateToNotSpecified;
        static const char *indicatorsPathNotSpecified;
        static const char *csvSourceNotSpecified;
    };
public:
    SampleParams(int, char **);
    ~SampleParams(void);

    const char *getInstrument();
    const char *getTimeframe();
    DATE getDateFrom();
    DATE getDateTo();
    const char *getIndicatorsPath();
    const char *getCSVSource();
    bool isBid();
private:
    const char *getRequiredArgument(int, char **, const char *, bool isBid = false);

    std::string mInstrument;
    std::string mTimeframe;
    DATE mDateFrom;
    DATE mDateTo;
    std::string mIndicatorsPath;
    std::string mCSVSource;
    bool mIsBid;
};
