#include <string>
#include <iostream>
#include "Tokenizer.h"

Tokenizer::Tokenizer(const std::string& s, const std::string& delimiters) :
    mString(s), 
    mOffset(0), 
    mDelimiters(delimiters) {}

const std::string Tokenizer::getToken() const
{
    return mToken;
}

void Tokenizer::reset()
{
    mOffset = 0;
    mToken.clear();
}

bool Tokenizer::nextToken() 
{
    size_t i = mString.find_first_not_of(mDelimiters, mOffset);
    if (i == std::string::npos) 
    {
        mOffset = mString.length();
        return false;
    }

    size_t j = mString.find_first_of(mDelimiters, i);
    if (j == std::string::npos) 
    {
        mToken = mString.substr(i);
        mOffset = mString.length();
        return true;
    }

    mToken = mString.substr(i, j - i);
    mOffset = j;
    return true;
}
